diff --git a/contrib/pg_upgrade/version_old_8_3.c b/contrib/pg_upgrade/version_old_8_3.c
new file mode 100644
index 84a47ee..e8438b6
*** a/contrib/pg_upgrade/version_old_8_3.c
--- b/contrib/pg_upgrade/version_old_8_3.c
*************** old_8_3_rebuild_tsvector_tables(ClusterI
*** 325,330 ****
--- 325,332 ----
  								"WHERE	c.relkind = 'r' AND "
  								"		c.oid = a.attrelid AND "
  								"		NOT a.attisdropped AND "
+ 		/* child attribute changes are processed by the parent */
+ 								"		a.attinhcount = 0 AND "
  								"		a.atttypid = 'pg_catalog.tsvector'::pg_catalog.regtype AND "
  								"		c.relnamespace = n.oid AND "
  		/* exclude possible orphaned temp tables */
*************** old_8_3_rebuild_tsvector_tables(ClusterI
*** 346,351 ****
--- 348,355 ----
  								"WHERE	c.relkind = 'r' AND "			\
  								"		c.oid = a.attrelid AND "		\
  								"		NOT a.attisdropped AND "		\
+ 		/* child attribute changes are processed by the parent */		\
+ 								"		a.attinhcount = 0 AND "			\
  								"		a.atttypid = 'pg_catalog.tsvector'::pg_catalog.regtype AND " \
  								"		c.relnamespace = n.oid AND "	\
  								"       n.nspname !~ '^pg_' AND "		\
